<template>
  <article class="view view--forum-topic-create">
    <LoadingSpinner v-if="loading" />
    <TopicCreateForm v-if="loaded" :section="section" />
  </article>
</template>

<script>
import { ref, computed, onMounted, watch } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, useApi, useNotification } from '../../../core'
import { useAuth } from '../../../identity'
import SectionsApi from '../../api/sections-api.js'
import TopicCreateForm from '../../components/topic-create-form.vue'

export default {
  name: 'ForumTopicCreateView',
  components: {
    LoadingSpinner,
    TopicCreateForm,
  },
  setup() {
    const route = useRoute()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const sectionsApi = new SectionsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)
    const section = ref(undefined)

    const codeName = computed(() => {
      return ValidationHelper.getString(route.params.codeName, '')
    })

    const iconClass = computed(() => {
      return route.meta.iconClass
    })

    const title = computed(() => {
      return route.meta.name
    })

    const sectionTitle = computed(() => {
      return section.value ? section.value.displayName : codeName.value
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Forum',
          route: { name: 'forum-forum' },
        },
        {
          text: sectionTitle.value,
          route: codeName.value ? { name: 'forum-section', params: { codeName: codeName.value } } : null,
        },
        {
          text: title.value,
          route: null,
        },
      ]
    })

    const loadSectionAsync = async () => {
      loading.value = true
      loaded.value = false

      try {
        const response = await sectionsApi.readAsync(codeName.value, { expand: 'all' })
        loaded.value = true
        section.value = response.data
      } catch (ex) {
        notify.error('There was a problem loading the section.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadSectionAsync()
      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
    })

    watch(title, (val) => {
      store.dispatch('core/setTitle', val)
    })

    watch(breadcrumbs, (val) => {
      store.dispatch('core/setBreadcrumbs', val)
    })

    store.dispatch('core/setIconClass', iconClass.value)

    return {
      loading,
      loaded,
      section,
    }
  },
}
</script>
